package com.jiuqi.util.zip;

package .tmp;

import com.jiuqi.util.zip.ZipFile;
import java.io.IOException;
import java.io.InputStream;

class BoundedInputStream extends InputStream {
  private long remaining;
  
  private long loc;
  
  private boolean addDummyByte = false;
  
  BoundedInputStream(long start, long remaining) {
    this.remaining = remaining;
    this.loc = start;
  }
  
  public int read() throws IOException {
    if (this.remaining-- <= 0L) {
      if (this.addDummyByte) {
        this.addDummyByte = false;
        return 0;
      } 
      return -1;
    } 
    synchronized (ZipFile.access$0(ZipFile.this)) {
      ZipFile.access$0(ZipFile.this).seek(this.loc++);
      return ZipFile.access$0(ZipFile.this).read();
    } 
  }
  
  public int read(byte[] b, int off, int len) throws IOException {
    if (this.remaining <= 0L) {
      if (this.addDummyByte) {
        this.addDummyByte = false;
        b[off] = 0;
        return 1;
      } 
      return -1;
    } 
    if (len <= 0)
      return 0; 
    if (len > this.remaining)
      len = (int)this.remaining; 
    int ret = -1;
    synchronized (ZipFile.access$0(ZipFile.this)) {
      ZipFile.access$0(ZipFile.this).seek(this.loc);
      ret = ZipFile.access$0(ZipFile.this).read(b, off, len);
    } 
    if (ret > 0) {
      this.loc += ret;
      this.remaining -= ret;
    } 
    return ret;
  }
  
  void addDummy() {
    this.addDummyByte = true;
  }
}
